(* AFC_vec Library *)

Require Import Vector_more.
Require Import Psatz.

(** * Axiom(s) of Finite Choice for Vectors *)

(** * Axioms of Finite Choices over vectors *)
Lemma AFCvec : forall {A} (P : nat -> A -> Prop) n (l : t _ n),
  (forall a i j, In a l -> P i a -> i <= j -> P j a) ->
    (Forall (fun x => exists k, P k x) l) -> exists k, Forall (P k) l.
Proof with try eassumption ; try reflexivity ; try lia.
induction l ; intros.
- exists 0 ; constructor.
- inversion H0 ; subst.
  apply inj_pairT2_nat in H3 ; subst.
  apply IHl in H5.
  + destruct H4 as [k1 Hk1].
    destruct H5 as [k2 Hk2].
    exists (max k1 k2) ; constructor.
    * eapply H...
      left.
    * revert Hk2 ; clear - H.
      induction l ; intro Hl ; constructor ; inversion Hl ; subst.
      -- eapply H...
         right ; left.
      -- apply inj_pairT2_nat in H2 ; subst.
         apply IHl...
         intros.
         eapply H...
         inversion H0 ; subst.
         ++ left.
         ++ apply inj_pairT2_nat in H8 ; subst.
            right ; right...
  + intros.
    eapply H...
    right...
Qed.

Lemma AFCvec_incdep : forall m (P : nat -> forall n, n < m -> Prop),
  (forall i n H1 H2, P i n H1 -> P i n H2) ->
  (forall n H i j, P i n H -> i <= j -> P j n H) ->
    (forall n H, exists k, P k n H) -> exists k, forall n H, P k n H.
Proof with try eassumption ; try (intros ; lia).
induction m ; intros P Hext Hinc HI.
- exists 0 ; intros n Hn ; inversion Hn.
- assert (forall n m, n < m -> n < S m) as Hsucc...
  assert (forall n H, exists k, P k n (Hsucc _ _ H)) as Hm
    by (intros ; apply HI).
  apply IHm in Hm.
  + destruct Hm as [k Hk].
    assert (forall n, n < S n) as Hsucc2...
    assert (exists k, P k m (Hsucc2 _)) as [k' Hk'] by (apply HI).
    exists (max (S k) (S k')).
    intros n Hn.
    inversion Hn ; subst.
    * apply (Hinc _ _ k')...
      eapply Hext ; apply Hk'.
    * apply (Hinc _ _ k)...
      assert (n < m) as Hlt...
      eapply Hext ; apply (Hk _ Hlt).
  + intros ; eapply Hext...
  + intros ; apply (Hinc _ _ i)...
Qed.




